# LuxorGraphPlot

A minimum package for displaying a graph and configurations defined on graphs.
It is the [`Luxor`](https://github.com/JuliaGraphics/Luxor.jl) version of [`GraphPlot`](https://github.com/JuliaGraphs/GraphPlot.jl).

Install by typing `using Pkg; Pkg.add("LuxorGraphPlot")` in a julia REPL.

(NOTE: After implementing this package, I noticed there is a similar package with more features: https://github.com/cormullion/Karnak.jl.)

## Example

In a notebook or IDE with graphical display, use the following statements to show your graph.

```julia
julia> using LuxorGraphPlot, Graphs

julia> show_graph(smallgraph(:petersen); format=:svg)
```
![](docs/src/assets/petersen.svg)

### Lower-level API

You can also use the lower-level API to customize the graph display.

```julia
using LuxorGraphPlot, LuxorGraphPlot.Luxor

drawing = nodestore() do ns
    c1 = circle!((-20.0, 0.0), 10)
    c2 = circle!((20.0, 0.0), 10)
    c3 = dot!((0.0, 20.0))
    with_nodes() do
        sethue("cyan")
        fill(c1)
        fill(c2)
        sethue("black")
        text("y", c1)
        text("x", c2)
        text("z", offset(c3, (10, 0)))
        line(c1, c2)
        line(midpoint(c1, c2), c3)
        end
    end
```

The output is as follows:

![](docs/src/assets/nodestore.svg)

module LuxorGraphPlot
using Luxor, Graphs
using LinearAlgebra
using MLStyle: @match

export show_graph, show_gallery, left, right, top, bottom, center, boundary, connect, offset, topright, topleft, bottomleft, bottomright
export bottomalign, topalign, rightalign, leftalign
export Node, Connection, circlenode, ellipsenode, boxnode, polygonnode, dotnode, linenode, tonode
export NodeStore, nodestore, with_nodes
export box!, circle!, polygon!, dot!, line!, stroke, ellipse!
export GraphDisplayConfig, GraphViz
export SpringLayout, StressLayout, SpectralLayout, render_locs, LayeredStressLayout, LayeredSpringLayout, AbstractLayout, Layred
export lighttheme!, darktheme!

include("nodes.jl")
include("layouts/layouts.jl")
using .Layouts: SpringLayout, StressLayout, SpectralLayout, render_locs, LayeredStressLayout, LayeredSpringLayout, AbstractLayout, Layered
include("nodestore.jl")
include("graphplot.jl")
include("tnet.jl")

end

abstract type AbstractNodeStore end

"""
    NodeStore <: AbstractNodeStore

A collection of nodes, which is used to infer the bounding box of a drawing.
"""
struct NodeStore <: AbstractNodeStore
    nodes::Vector{Node}
end
NodeStore() = NodeStore(Node[])
nodes(d::NodeStore) = d.nodes
function Base.push!(d::NodeStore, obj::Node)
    push!(d.nodes, obj)
    return d
end
function Base.append!(d::NodeStore, objs)
    append!(d.nodes, objs)
    return d
end
function get_bounding_box(d::AbstractNodeStore)
    nds = nodes(d)
    isempty(nds) && return (0.0, 0.0, 0.0, 0.0)
    xmin_val, xmax_val, ymin_val, ymax_val = Inf, -Inf, Inf, -Inf
    for n in nds
        path = getpath(n)
        xmin_val = min(xmin_val, xmin(path))
        xmax_val = max(xmax_val, xmax(path))
        ymin_val = min(ymin_val, ymin(path))
        ymax_val = max(ymax_val, ymax(path))
    end
    return xmin_val, xmax_val, ymin_val, ymax_val
end

const CURRENT_CONTEXT = Base.RefValue{AbstractNodeStore}(NodeStore())
function setcontext!(d::AbstractNodeStore)
    CURRENT_CONTEXT[] = d
    return d
end
function emptycontext!()
    CURRENT_CONTEXT[] = NodeStore()
end
function getcontext!()
    return CURRENT_CONTEXT[]
end

for F in [:line, :dot, :circle, :box, :polygon, :ellipse]
    SF = String(F)
    @eval begin
        """
            $($SF)!([nodestore, ]args...; kwargs...) = push!(nodestore, $($SF)node(args...; kwargs...))

        Add a $($SF) shaped node to the nodestore. Please refer to [`$($SF)node`](@ref) for more information.
        If `nodestore` is not provided, the current nodestore is used.
        """
        function $(Symbol(F, :!))(args...; kwargs...)
            obj = $(Symbol(F, :node))(args...; kwargs...)
            push!(getcontext!(), obj)
            return obj
        end
        function $(Symbol(F, :!))(d::AbstractNodeStore, args...; kwargs...)
            obj = $(Symbol(F, :node))(args...; kwargs...)
            push!(d, obj)
            return obj
        end
    end
end

"""
    nodestore(f)

Create a [`NodeStore`](@ref) context, such that [`box!`](@ref), [`circle!`](@ref), [`polygon!`](@ref), [`dot!`](@ref) and [`line!`](@ref) will add nodes to the nodestore.
The nodestore is passed to the function `f` as an argument.

### Example
```julia
julia> using LuxorGraphPlot, LuxorGraphPlot.Luxor

julia> nodestore() do ns
    box = box!(ns, (100, 100), 100, 100)
    circle = circle!(ns, (200, 200), 50)
    with_nodes(ns) do
        stroke(box)
        stroke(circle)
        Luxor.line(topright(box), circle)
    end
end
```
"""
function nodestore(f)
    d = NodeStore()
    setcontext!(d)
    drawing = f(d)
    emptycontext!()
    return drawing
end

"""
    with_nodes(f[, nodestore]; kwargs...)

Create a drawing with the nodes in the nodestore.
The bounding box of the drawing is determined by the bounding box of the nodes in the nodestore.
If `nodestore` is not provided, the current nodestore is used.

### Keyword arguments
- `padding_left::Int=10`: Padding on the left side of the drawing.
- `padding_right::Int=10`: Padding on the right side of the drawing.
- `padding_top::Int=10`: Padding on the top side of the drawing.
- `padding_bottom::Int=10`: Padding on the bottom side of the drawing.
- `format::Symbol=:svg`: The format of the drawing. Available formats are `:png`, `:pdf`, `:svg`...
- `filename::String=nothing`: The filename of the drawing. If `nothing`, a temporary file is created.
- `background::String="white"`: The background color of the drawing.
"""
with_nodes(f; kwargs...) = with_nodes(f, getcontext!(); kwargs...)
function with_nodes(f, d::AbstractNodeStore;
        padding_left=10, padding_right=10,
        padding_top=10, padding_bottom=10,
        format=:svg, filename=nothing,
        background="white"
    )
    xmin, xmax, ymin, ymax = get_bounding_box(d) .+ (-padding_left, padding_right, -padding_top, padding_bottom)
    Luxor.Drawing(ceil(Int, xmax - xmin), ceil(Int, ymax - ymin), filename === nothing ? format : filename)
    Luxor.origin(-xmin, -ymin)
    Luxor.background(background)
    f()
    Luxor.finish()
    Luxor.preview()
end

## Show a graph
using Graphs, LuxorGraphPlot, LuxorGraphPlot.Luxor

# Show a graph with spring (default) layout.

graph = smallgraph(:petersen)

show_graph(graph)

# specify the layout and texts manually

rot15(a, b, i::Int) = cos(2i*π/5)*a + sin(2i*π/5)*b, cos(2i*π/5)*b - sin(2i*π/5)*a
locations = [[rot15(0.0, 50.0, i) for i=0:4]..., [rot15(0.0, 25.0, i) for i=0:4]...]
show_graph(graph, locations,
        texts=[string('a'+i) for i=0:9], padding_right=300,
        config=GraphDisplayConfig(; background="gray")) do nd
    ## extra commands, transformer is a function that convert graph-axis to canvas axis.
    LuxorGraphPlot.Luxor.fontsize(22)
    xmin, xmax, ymin, ymax = LuxorGraphPlot.get_bounding_box(nd)
    LuxorGraphPlot.text("haha, the fontsize is so big!", Point(xmax + 20, (ymin + ymax) / 2))
end

# specify colors, shapes and sizes

show_graph(graph;
	vertex_colors=rand(["blue", "red"], 10),
	vertex_sizes=rand(10) .* 10 .+ 5,
	vertex_stroke_colors=rand(["blue", "red"], 10),
	vertex_text_colors=rand(["white", "black"], 10),
	edge_colors=rand(["blue", "red"], 15),
	vertex_shapes=rand([:circle, :box], 10)
)

# for uniform colors/sizes, you can make life easier by specifying global colors.

show_graph(graph;
    config = GraphDisplayConfig(
        vertex_color="blue",
        vertex_size=7.5,
        vertex_stroke_color="transparent",
        vertex_text_color="white",
        edge_color="green"
    )
)

# One can also dump an image to a file

show_graph(graph; format=:svg)

# or render it in another format

show_graph(graph; format=:svg)

# ## Layouts

# The default layout is `:auto`, which uses `:spring` if `locs` is `nothing`.

show_graph(graph, SpringLayout())

show_graph(graph, StressLayout())

show_graph(graph, SpectralLayout())

# ## Show a gallery

# One can use a boolean vector to represent boolean variables on a vertex or an edge.

locs = render_locs(graph, SpringLayout())
matrix = [GraphViz(graph, locs; vertex_colors=[rand(Luxor.RGB) for i=1:10],
    edge_colors=[rand(Luxor.RGB) for i=1:15]) for i=1:2, j=1:4]
show_gallery(matrix; format=:png, padding_left=20, padding_right=20, padding_top=20, padding_bottom=20)

using LuxorGraphPlot, Graphs
using Test, Documenter

@testset "layouts" begin
    include("layouts/layouts.jl")
end

@testset "graphplot" begin
    include("graphplot.jl")
end

@testset "nodes" begin
    include("nodes.jl")
end

@testset "nodestore" begin
    include("nodestore.jl")
end

Documenter.doctest(LuxorGraphPlot)

"""
    StressLayout <: AbstractLayout

A layout algorithm based on stress majorization.

### Fields
* `optimal_distance::Float64`: the optimal distance between vertices
* `maxiter::Int`: the maximum number of iterations
* `rtol::Float64`: the absolute tolerance
* `initial_locs`: initial vertex locations
* `mask`: boolean mask for which vertices to relocate
* `meta::Dict{Symbol, Any}`: graph dependent meta information, including
    * `initial_locs`: initial vertex locations
    * `mask`: boolean mask for which vertices to relocate
"""
@kwdef struct StressLayout <: AbstractLayout
    optimal_distance::Float64 = 50.0
    maxiter::Int = 100
    rtol::Float64 = 1e-2
    meta::Dict{Symbol, Any} = Dict{Symbol, Any}()
end

function render_locs(graph, l::StressLayout)
    return stressmajorize_layout(graph;
                        optimal_distance=l.optimal_distance,
                        maxiter=l.maxiter,
                        rtol=l.rtol,
                        locs=get(l.meta, :initial_locs, nothing),
                        mask=get(l.meta, :mask, nothing),
                    )
end

"""
    stressmajorize_layout(g::AbstractGraph;
                               locs=rand_points_2d(nv(g)),
                               w=nothing,
                               optimal_distance=50.0,   # the optimal vertex distance
                               maxiter = 400 * nv(g)^2,
                               rtol=1e-2,
                               )

Stress majorization layout for graph plotting, returns a vector of vertex locations.

### References
* https://github.com/JuliaGraphs/GraphPlot.jl/blob/e97063729fd9047c4482070870e17ed1d95a3211/src/stress.jl
"""
function stressmajorize_layout(g::AbstractGraph;
                               optimal_distance=50.0,   # the optimal vertex distance
                               locs=nothing,
                               w=nothing,
                               maxiter = 400 * nv(g)^2,
                               rtol=1e-2,
                               mask=nothing,
                               )

    locs = locs === nothing ? rand_points_2d(nv(g)) .* optimal_distance : Point.(locs)
    mask = mask === nothing ? trues(nv(g)) : mask
    # the extra factor 3 is for matching the spring layout result
    δ = 3 * optimal_distance .* hcat([gdistances(g, i) for i=1:nv(g)]...)

    if w === nothing
        w = δ .^ -2
        w[.!isfinite.(w)] .= 0
    end

    @assert length(locs)==size(δ, 1)==size(δ, 2)==size(w, 1)==size(w, 2)
    locs = copy(locs)
    Lw = weighted_laplacian(w)
    pinvLw = pinv(Lw)
    newstress = stress(locs, δ, w)
    iter = 0
    L = zeros(eltype(Lw), nv(g), nv(g))
    local locs_new
    for outer iter = 1:maxiter
        lz = LZ!(L, locs, δ, w)
        locs_new = pinvLw * (lz * locs)
        @assert all(isfinite.(locs_new))
        newstress, oldstress = stress(locs_new, δ, w), newstress
        @debug """Iteration $iter
        Change in coordinates: $(sum(distance.(locs_new, locs))/length(locs))
        Stress: $newstress (change: $(newstress-oldstress))
        """
        isapprox(newstress, oldstress; rtol) && break
        locs[mask] = locs_new[mask]
    end
    iter == maxiter && @warn("Maximum number of iterations reached without convergence")
    return locs
end

function stress(locs::AbstractVector{Point{D, T}}, d, w) where {D, T}
    s = 0.0
    n = length(locs)
    @assert n==size(d, 1)==size(d, 2)==size(w, 1)==size(w, 2)
    @inbounds for j=1:n, i=1:j-1
        s += w[i, j] * (distance(locs[i], locs[j]) - d[i,j])^2
    end
    return s
end

function weighted_laplacian(w::AbstractMatrix{T}) where T
    n = LinearAlgebra.checksquare(w)
    Lw = zeros(T, n, n)
    for i=1:n
        D = zero(T)
        for j=1:n
            i==j && continue
            Lw[i, j] = -w[i, j]
            D += w[i, j]
        end
        Lw[i, i] = D
    end
    return Lw
end

function LZ!(L::AbstractMatrix{T}, locs::AbstractVector{Point{D, T2}}, d, w) where {D, T, T2}
    @assert length(locs)==size(d, 1)==size(d, 2)==size(w, 1)==size(w, 2)
    fill!(L, zero(T))
    n = length(locs)
    @inbounds for i=1:n-1
        diag = zero(T)
        for j=i+1:n
            nrmz = distance(locs[i], locs[j])
            δ = w[i, j] * d[i, j]
            lij = -δ/max(nrmz, 1e-8)
            L[i, j] = lij
            diag -= lij
        end
        L[i, i] += diag
    end
    @inbounds for i=2:n
        diag = zero(T)
        for j=1:i-1
            lij = L[j,i]
            L[i,j] = lij
            diag -= lij
        end
        L[i,i] += diag
    end
    return L
end

"""
    LayeredStressLayout(; zlocs, optimal_distance, aspect_ration=0.2)

Create a layered stress layout.

### Keyword Arguments
* `zlocs`: the z-axis locations
* `optimal_distance::Float64`: the optimal distance between vertices
* `aspect_ration::Float64`: the aspect ratio of the z-axis
* `maxiter::Int`: the maximum number of iterations
* `rtol::Float64`: the absolute tolerance
"""
function LayeredStressLayout(; zlocs, optimal_distance=50.0, aspect_ratio=0.2, maxiter=100, rtol=1e-2)
    return Layered(StressLayout(; optimal_distance, maxiter, rtol), zlocs, aspect_ratio)
end

using Test, LuxorGraphPlot, Graphs
using Luxor: Drawing

@testset "layouts" begin
    graph = smallgraph(:petersen)
    for layout in [:auto, :spring, :spectral, :stress]
        @test show_graph(graph; layout) isa Drawing
        @test show_gallery(graph, (2,4); vertex_configs=[rand(Bool, 15) for i=1:10], edge_configs=[rand(Bool, 15) for i=1:10], layout) isa Drawing
    end
    locs = [(randn(2)...,) for i=1:10]
    @test show_graph(graph; layout=:auto) isa Drawing
    @test show_gallery(graph, (2,4); vertex_configs=[rand(Bool, 15) for i=1:10], edge_configs=[rand(Bool, 15) for i=1:10], layout=:auto) isa Drawing
end

const CONFIGHELP = """
* `fontsize::Float64 = 12.0`, the font size
* `fontface::String = ""`, the font face, leave empty to follow system

* `vertex_text_color = "black"`, the default text color
* `vertex_stroke_color = "black"`, the default stroke color for vertices
* `vertex_color = "transparent"`, the default default fill color for vertices
* `vertex_size::Float64 = 10.0`, the default vertex size
* `vertex_shape::Symbol = :circle`, the default vertex shape, which can be :circle, :box or :dot
* `vertex_line_width::Float64 = 1`, the default vertex stroke line width
* `vertex_line_style::String = "solid"`, the line style of vertex stroke, which can be one of ["solid", "dotted", "dot", "dotdashed", "longdashed", "shortdashed", "dash", "dashed", "dotdotdashed", "dotdotdotdashed"]

* `edge_color = "black"`, the default edge color
* `edge_line_width::Float64 = 1`, the default line width
* `edge_style::String = "solid"`, the line style of edges, which can be one of ["solid", "dotted", "dot", "dotdashed", "longdashed", "shortdashed", "dash", "dashed", "dotdotdashed", "dotdotdotdashed"]
"""

const VIZHELP = """
* `vertex_colors` is a vector of color strings for specifying vertex fill colors.
* `vertex_sizes` is a vector of real numbers for specifying vertex sizes.
* `vertex_shapes` is a vector of strings for specifying vertex shapes, the string should be "circle" or "box".
* `vertex_stroke_colors` is a vector of color strings for specifying vertex stroke colors.
* `vertex_text_colors` is a vector of color strings for specifying vertex text colors.
* `edge_colors` is a vector of color strings for specifying edge colors.
* `texts` is a vector of strings for labeling vertices.
"""

"""
    GraphDisplayConfig

The configuration for graph display.

Keyword arguments
-------------------------------
* `locs` is a vector of tuples for specifying the vertex locations.
* `edges` is a vector of tuples for specifying the edges.
$CONFIGHELP
"""
Base.@kwdef mutable struct GraphDisplayConfig
    # line, vertex and text
    fontface::String = ""
    background::String = "white"
    fontsize::Float64 = 12.0
    # vertex
    vertex_shape::Symbol = :circle
    vertex_line_width::Float64 = 1.0  # in pt
    vertex_line_style::String = "solid"
    vertex_text_color::String = "black"
    vertex_stroke_color::String = "black"
    vertex_color::String = "transparent"
    vertex_size::Float64 = 10.0
    # edge
    edge_color::String = "black"
    edge_line_width::Float64 = 1.0  # in pt
    edge_line_style::String = "solid"
end
Base.copy(config::GraphDisplayConfig) = deepcopy(config)

"""
    darktheme!(config::GraphDisplayConfig)

Set the dark theme for the graph display.
"""
darktheme!(config::GraphDisplayConfig) = begin
    config.background = "transparent"
    config.vertex_text_color = "white"
    config.vertex_stroke_color = "white"
    config.edge_color = "white"
    return config
end

"""
    lighttheme!(config::GraphDisplayConfig)

Set the light theme for the graph display.
"""
lighttheme!(config::GraphDisplayConfig) = begin
    config.background = "transparent"
    config.vertex_text_color = "black"
    config.vertex_stroke_color = "black"
    config.edge_color = "black"
    return config
end

"""
    GraphViz

The struct for storing graph visualization information.

Keyword arguments
-------------------------------
$VIZHELP
"""
Base.@kwdef mutable struct GraphViz
    locs::Vector{Tuple{Float64, Float64}}
    edges::Vector{Tuple{Int, Int}}
    vertex_shapes = nothing
    vertex_sizes = nothing
    vertex_colors = nothing
    vertex_stroke_colors = nothing
    vertex_text_colors = nothing
    edge_colors = nothing
    texts = nothing
end
function GraphViz(graph::SimpleGraph, locs=SpringLayout(); kwargs...)
    rlocs = getfield.(render_locs(graph, locs), :data)
    return GraphViz(; locs=rlocs, edges=[(src(e), dst(e)) for e in edges(graph)], kwargs...)
end
get_bounding_box(g::GraphViz) = (minimum(getindex.(g.locs, 1)), maximum(getindex.(g.locs, 1)), minimum(getindex.(g.locs, 2)), maximum(getindex.(g.locs, 2)))

struct GraphDiagram <: AbstractNodeStore
    nodes::Vector{Node}
    edges::Vector{Connection}
end
nodes(d::GraphDiagram) = d.nodes
function offset(d::GraphDiagram, point)
    GraphDiagram([offset(n, point) for n in d.nodes], [offset(e, point) for e in d.edges])
end

"""
    show_graph([f, ]graph::AbstractGraph;
        kwargs...
        )

Show a graph in VSCode, Pluto or Jupyter notebook, or save it to a file.

Positional arguments
-----------------------------
* `f` is a function that returns extra `Luxor` plotting statements.
* `graph` is a graph instance.
* `locs` is a vector of tuples for specifying the vertex locations, or a [`AbstractLayout`](@ref) instance.

Keyword arguments
-----------------------------
* `config` is a [`GraphDisplayConfig`](@ref) instance.

$VIZHELP

* `padding_left::Int = 10`, the padding on the left side of the drawing
* `padding_right::Int = 10`, the padding on the right side of the drawing
* `padding_top::Int = 10`, the padding on the top side of the drawing
* `padding_bottom::Int = 10`, the padding on the bottom side of the drawing

* `format` is the output format, which can be `:svg`, `:png` or `:pdf`.
* `filename` is a string as the output filename.

Example
------------------------------
```jldoctest
julia> using Graphs, LuxorGraphPlot

julia> show_graph(smallgraph(:petersen); format=:png, vertex_colors=rand(["blue", "red"], 10));
```
"""
show_graph(graph::GraphViz; kwargs...) = show_graph(x->nothing, graph; kwargs...)
show_graph(graph::SimpleGraph, locs=SpringLayout(); kwargs...) = show_graph(x->nothing, graph, locs; kwargs...)
function show_graph(f, g::GraphViz;
        format = :svg,
        filename = nothing,
        padding_left = 10,
        padding_right = 10,
        padding_top = 10,
        padding_bottom = 10,
        config = GraphDisplayConfig(),
    )
    diag = diagram(g.locs, g.edges; vertex_shapes=g.vertex_shapes, vertex_sizes=g.vertex_sizes, config)
    with_nodes(diag; format, filename, padding_bottom, padding_left, padding_right, padding_top, background=config.background) do
        f(diag)
        show_diagram(diag; config,
            texts=g.texts,
            vertex_colors=g.vertex_colors,
            vertex_stroke_colors = g.vertex_stroke_colors,
            vertex_text_colors = g.vertex_text_colors,
            edge_colors = g.edge_colors)
    end
end

function diagram(locs, edges; vertex_sizes=nothing, vertex_shapes=nothing, config=GraphDisplayConfig())
    nodes = Node[]
    for i in eachindex(locs)
        shape = _get(vertex_shapes, i, config.vertex_shape)
        vertex_size = _get(vertex_sizes, i, config.vertex_size)
        props = Dict(
                :circle => Dict(:radius=>vertex_size),
                :box => Dict(:width=>2*vertex_size, :height=>2*vertex_size),
                :dot => Dict()
            )[shape]
        push!(nodes, Node(shape, locs[i]; props...))
    end
    edgs = Connection[]
    for (i, j) in edges
        push!(edgs, Connection(nodes[i], nodes[j]))
    end
    return GraphDiagram(nodes, edgs)
end
function show_graph(f, graph::SimpleGraph, locs=SpringLayout();
        vertex_shapes = nothing,
        vertex_sizes = nothing,
        vertex_colors = nothing,
        vertex_stroke_colors = nothing,
        vertex_text_colors = nothing,
        edge_colors = nothing,
        texts = nothing,
        padding_left = 10,
        padding_right = 10,
        padding_top = 10,
        padding_bottom = 10,
        format = :svg,
        filename = nothing,
        config = GraphDisplayConfig()
    )
    viz = GraphViz(graph, locs;
            vertex_shapes, vertex_sizes, vertex_colors, vertex_stroke_colors,
            vertex_text_colors, edge_colors, texts)
    show_graph(f, viz; format, filename, padding_bottom, padding_left, padding_right, padding_top, config)
end

function show_diagram(diag::GraphDiagram;
            config=GraphDisplayConfig(),
            vertex_colors,
            vertex_stroke_colors,
            vertex_text_colors,
            texts,
            edge_colors)
    render_edges(diag.edges, config; edge_colors)
    render_nodes(diag.nodes, config; texts, vertex_colors, vertex_stroke_colors, vertex_text_colors)
end

function render_nodes(nodes::AbstractVector, config::GraphDisplayConfig; texts=nothing, vertex_colors=nothing, vertex_stroke_colors=nothing, vertex_text_colors=nothing)
    setline(config.vertex_line_width)
    setdash(config.vertex_line_style)
    Luxor.fontsize(config.fontsize)
    !isempty(config.fontface) && Luxor.fontface(config.fontface)
    for (i, node) in enumerate(nodes)
        setcolor(_get(vertex_colors, i, config.vertex_color))
        fill(node)
        setcolor(_get(vertex_stroke_colors, i, config.vertex_stroke_color))
        stroke(node)
        text = _get(texts, i, "")
        if !isempty(text)
            setcolor(_get(vertex_text_colors, i, config.vertex_text_color))
            Luxor.text(text, node)
        end
    end
end

function render_edges(edges::AbstractVector, config::GraphDisplayConfig; edge_colors=nothing)
    setline(config.edge_line_width)
    setdash(config.edge_line_style)
    for (k, e) in enumerate(edges)
        setcolor(_get(edge_colors, k, config.edge_color))
        stroke(e)
    end
end

_get(::Nothing, i, default) = default
_get(x, i, default) = x[i]

"""
    show_gallery([f, ]stores::AbstractMatrix{GraphViz};
        kwargs...
        )

Show a gallery of graphs in VSCode, Pluto or Jupyter notebook, or save it to a file.

Positional arguments
-----------------------------
* `f` is a function that returns extra `Luxor` plotting statements.
* `stores` is a matrix of `GraphViz` instances.

Keyword arguments
-----------------------------
* `config` is a [`GraphDisplayConfig`](@ref) instance.

* `padding_left::Int = 10`, the padding on the left side of the drawing
* `padding_right::Int = 10`, the padding on the right side of the drawing
* `padding_top::Int = 10`, the padding on the top side of the drawing
* `padding_bottom::Int = 10`, the padding on the bottom side of the drawing

* `format` is the output format, which can be `:svg`, `:png` or `:pdf`.
* `filename` is a string as the output filename.
"""
function show_gallery(f, stores::AbstractMatrix{GraphViz};
        padding_left=10, padding_right=10,
        padding_top=10, padding_bottom=10,
        config=GraphDisplayConfig(),
        format=:svg,
        filename=nothing
    )
    if isempty(stores)
        return Luxor.Drawing(1, 1, filename === nothing ? format : filename)
    end
    xmin, _, ymin, _ = get_bounding_box(stores[1, 1]) .+ (-padding_left, padding_right, -padding_top, padding_bottom)
    xspans = map(stores[1, :]) do d
        xmin, xmax, _, _ = get_bounding_box(d) .+ (-padding_left, padding_right, -padding_top, padding_bottom)
        xmax - xmin
    end
    yspans = map(stores[:, 1]) do d
        _, _, ymin, ymax = get_bounding_box(d) .+ (-padding_left, padding_right, -padding_top, padding_bottom)
        ymax - ymin
    end
    m, n = size(stores)
    xoffsets = cumsum([0; xspans[1:end-1]])
    yoffsets = cumsum([0; yspans[1:end-1]])

    Luxor.Drawing(ceil(Int, sum(xspans)), ceil(Int, sum(yspans)), filename === nothing ? format : filename)
    Luxor.origin(-xmin, -ymin)
    Luxor.background(config.background)
    for i=1:m, j=1:n
        g = stores[i, j]
        diag_ = diagram(g.locs, g.edges; vertex_shapes=g.vertex_shapes, vertex_sizes=g.vertex_sizes, config)
        diag = offset(diag_, (xoffsets[j], yoffsets[i]))
        f(diag)
        show_diagram(diag; config,
            texts=g.texts,
            vertex_colors=g.vertex_colors,
            vertex_stroke_colors = g.vertex_stroke_colors,
            vertex_text_colors = g.vertex_text_colors,
            edge_colors = g.edge_colors)
    end
    Luxor.finish()
    Luxor.preview()
end
show_gallery(stores::AbstractMatrix{GraphViz}; kwargs...) = show_gallery(x->nothing, stores; kwargs...)

"""
    spring_layout(g::AbstractGraph;
                       locs_x=2*rand(nv(g)).-1.0,
                       locs_y=2*rand(nv(g)).-1.0,
                       C=2.0,   # the optimal vertex distance
                       MAXITER=100,
                       INITTEMP=2.0,
                       mask::AbstractVector{Bool}=trues(length(locs_x))   # mask for which to relocate
                       )

Spring layout for graph plotting, returns a vector of vertex locations.

!!! note
    This function is copied from [`GraphPlot.jl`](https://github.com/JuliaGraphs/GraphPlot.jl),
    where you can find more information about his function.
"""
function spring_layout(g::AbstractGraph;
                       locs_x=2*rand(nv(g)).-1.0,
                       locs_y=2*rand(nv(g)).-1.0,
                       C=2.0,   # the optimal vertex distance
                       MAXITER=100,
                       INITTEMP=2.0,
                       mask::AbstractVector{Bool}=trues(length(locs_x))   # mask for which to relocate
                       )

    locs_x, locs_y = copy(locs_x), copy(locs_y)
    nvg = nv(g)
    adj_matrix = adjacency_matrix(g)

    # The optimal distance bewteen vertices
    k = C * sqrt(4.0 / nvg)
    k² = k * k

    # Store forces and apply at end of iteration all at once
    force_x = zeros(nvg)
    force_y = zeros(nvg)

    # Iterate MAXITER times
    @inbounds for iter = 1:MAXITER
        # Calculate forces
        for i = 1:nvg
            force_vec_x = 0.0
            force_vec_y = 0.0
            for j = 1:nvg
                i == j && continue
                d_x = locs_x[j] - locs_x[i]
                d_y = locs_y[j] - locs_y[i]
                dist²  = (d_x * d_x) + (d_y * d_y)
                dist = sqrt(dist²)

                if !( iszero(adj_matrix[i,j]) && iszero(adj_matrix[j,i]) )
                    # Attractive + repulsive force
                    # F_d = dist² / k - k² / dist # original FR algorithm
                    F_d = dist / k - k² / dist²
                else
                    # Just repulsive
                    # F_d = -k² / dist  # original FR algorithm
                    F_d = -k² / dist²
                end
                force_vec_x += F_d*d_x
                force_vec_y += F_d*d_y
            end
            force_x[i] = force_vec_x
            force_y[i] = force_vec_y
        end
        # Cool down
        temp = INITTEMP / iter
        # Now apply them, but limit to temperature
        for i = 1:nvg
            mask[i] || continue
            fx = force_x[i]
            fy = force_y[i]
            force_mag  = sqrt((fx * fx) + (fy * fy))
            scale      = min(force_mag, temp) / force_mag
            locs_x[i] += force_x[i] * scale
            locs_y[i] += force_y[i] * scale
        end
    end

    locs_x, locs_y
end

# Source: https://github.com/JuliaGraphs/GraphPlot.jl/blob/e97063729fd9047c4482070870e17ed1d95a3211/src/stress.jl
function stressmajorize_layout(g::AbstractGraph;
                               locs_x=2*rand(nv(g)) .- 1.0,
                               locs_y=2*rand(nv(g)) .- 1.0,
                               w=nothing,
                               C=2.0,   # the optimal vertex distance
                               maxiter = 400 * nv(g)^2,
                               abstols=1e-2,
                               reltols=1e-2,
                               abstolx=1e-2,
                               verbose = false)

    #δ = fill(1.0, nv(g), nv(g))
    δ = C .* hcat([gdistances(g, i) for i=1:nv(g)]...)
    X0 = hcat(locs_x, locs_y)

    if w === nothing
        w = δ .^ -2
        w[.!isfinite.(w)] .= 0
    end

    @assert size(X0, 1)==size(δ, 1)==size(δ, 2)==size(w, 1)==size(w, 2)
    Lw = weightedlaplacian(w)
    pinvLw = pinv(Lw)
    newstress = stress(X0, δ, w)
    iter = 0
    L = zeros(nv(g), nv(g))
    local X
    for outer iter = 1:maxiter
        #TODO the faster way is to drop the first row and col from the iteration
        X = pinvLw * (LZ!(L, X0, δ, w)*X0)
        @assert all(isfinite.(X))
        newstress, oldstress = stress(X, δ, w), newstress
        verbose && @info("""Iteration $iter
        Change in coordinates: $(norm(X - X0))
        Stress: $newstress (change: $(newstress-oldstress))
        """)
        if abs(newstress - oldstress) < reltols * newstress ||
                abs(newstress - oldstress) < abstols ||
                norm(X - X0) < abstolx
            break
        end
        X0 = X
    end
    iter == maxiter && @warn("Maximum number of iterations reached without convergence")
    return X[:,1], X[:,2]
end

function stress(X, d, w)
    s = 0.0
    n = size(X, 1)
    @assert n==size(d, 1)==size(d, 2)==size(w, 1)==size(w, 2)
    @inbounds for j=1:n, i=1:j-1
        s += w[i, j] * (sqrt(sum(k->abs2(X[i,k] - X[j,k]), 1:size(X,2))) - d[i,j])^2
    end
    @assert isfinite(s)
    return s
end

function weightedlaplacian(w)
    n = LinearAlgebra.checksquare(w)
    T = eltype(w)
    Lw = zeros(T, n, n)
    for i=1:n
        D = zero(T)
        for j=1:n
            i==j && continue
            Lw[i, j] = -w[i, j]
            D += w[i, j]
        end
        Lw[i, i] = D
    end
    return Lw
end

function LZ!(L, Z, d, w)
    fill!(L, zero(eltype(L)))
    n = size(Z, 1)
    @inbounds for i=1:n-1
        D = 0.0
        for j=i+1:n
            nrmz = sqrt(sum(k->abs2(Z[i,k] - Z[j,k]), 1:size(Z,2)))
            δ = w[i, j] * d[i, j]
            lij = -δ/max(nrmz, 1e-8)
            L[i, j] = lij
            D -= lij
        end
        L[i, i] += D
    end
    @inbounds for i=2:n
        D = 0.0
        for j=1:i-1
            lij = L[j,i]
            L[i,j] = lij
            D -= lij
        end
        L[i,i] += D
    end
    return L
end

function spectral_layout(g::AbstractGraph, weight=nothing)
    if nv(g) == 1
        return [0.0], [0.0]
    elseif nv(g) == 2
        return [0.0, 1.0], [0.0, 0.0]
    end

    if weight == nothing
        weight = ones(ne(g))
    end
    if nv(g) > 500
        A = Graphs.sparse(Int[src(e) for e in edges(g)],
                   Int[dst(e) for e in edges(g)],
                   weight, nv(g), nv(g))
        if is_directed(g)
            A = A + transpose(A)
        end
        return _spectral(A)
    else
        L = laplacian_matrix(g)
        return _spectral(Matrix(L))
    end
end

function _spectral(L::Matrix)
    eigenvalues, eigenvectors = eigen(L)
    index = sortperm(eigenvalues)[2:3]
    return eigenvectors[:, index[1]], eigenvectors[:, index[2]]
end

function _spectral(A)
    data = vec(sum(A, dims=1))
    D = Graphs.sparse(Base.OneTo(length(data)), Base.OneTo(length(data)), data)
    L = D - A
    eigenvalues, eigenvectors = Graphs.LinAlg.eigs(L, nev=3, which=Graphs.SR())
    index = sortperm(real(eigenvalues))[2:3]
    return real(eigenvectors[:, index[1]]), real(eigenvectors[:, index[2]])
end

using Test, LuxorGraphPlot
using LuxorGraphPlot.Layouts: Point, distance, norm, rand_points_2d

@testset "Point" begin
    p1 = Point(1.0, 2.0)
    @test p1[1] == 1.0
    p2 = Point(3.0, 4.0)
    @test p1 + p2 ≈ Point(4.0, 6.0)
    @test norm(p1) == sqrt(5)
    @test distance(p1, p2) == sqrt(8)

    @test rand_points_2d(10) isa Vector{Point{2, Float64}}
    @test rand(Point{2, Float64}) isa Point{2, Float64}
    @test randn(Point{2, Float64}) isa Point{2, Float64}
end

using LuxorGraphPlot, LuxorGraphPlot.Luxor
using LuxorGraphPlot.TensorNetwork

# ## Node styles
# We a combination of [`nodestore`](@ref) and [`with_nodes`](@ref) to draw nodes with automatically inferred bounding boxes.
nodestore() do ns  # store nodes in the nodestore (used to infer the bounding box)
    a = circle!((0, 0), 30)
    b = ellipse!((100, 0), 60, 40)
    c = box!((200, 0), 50, 50; smooth=10)
    d = polygon!([rotatepoint(Point(30, 0), i*π/3) for i=1:6] .+ Ref(Point(300, 0)); smooth=5)
    with_nodes(ns) do  # the context manager to draw nodes
        fontsize(6)
        for (node, shape) in [(a, "circle"), (b, "ellipse"), (c, "box"), (d, "polygon")]
            stroke(node)
            text(shape, node)
            for p in [left, right, top, bottom, topleft, bottomleft, topright, bottomright, LuxorGraphPlot.center]
                text(string(p), offset(fill(circlenode(p(node), 3)), (0, 6)))
            end
        end
    end
end

# ## Connection points
nodestore() do ns
    a1 = circle!((150, 150), 30)
    a2 = circle!((450, 150), 30)
    box1s = [offset(boxnode(rotatepoint(Point(100, 0), i*π/8), 20, 20), a1.loc) for i=1:16]
    box2s = offset.(box1s, Ref(a2.loc-a1.loc))
    append!(ns, box1s)
    append!(ns, box2s)
    with_nodes(ns) do
        fontsize(14)
        stroke(a1)
        stroke(a2)
        for b in box1s
            stroke(b)
            line(a1, b; mode=:exact)
        end
        for b in box2s
            stroke(b)
            line(a2, b; mode=:natural)
        end
        text("exact", a1)
        text("natural", a2)
    end
end
        
# ## Connector styles
nodestore() do ns
	radius = 30
    a = boxnode(Point(50, 50), 40, 40; smooth=5)
    b = offset(a, (100, 0))
    groups = Matrix{Vector{Node}}(undef, 2, 3)
    for j=0:1
        for k = 0:2
            items = [offset(a, (200k, 150j)), offset(b, (200k, 150j))]
            groups[j+1, k+1] = items
            append!(ns, items)
            push!(ns, offset(midpoint(items...), (0, 70)))
        end
    end
    with_nodes() do
        fontsize(28)
        ## the default smooth method is "curve", it must take two control points.
        for j=1:2
            for k = 1:3
                a, b = groups[j, k]
                cps  = [[offset(midpoint(a, b), (0, 50))], [offset(a, (0, 50)), offset(b, (0, 50))]][j]
                smoothprops = [
                    Dict(:method=>length(cps) == 1 ? "nosmooth" : "curve"),
                    Dict(:method=>"smooth", :radius=>10),
                    Dict(:method=>"bezier", :radius=>10),
                ][k]
                stroke(a)
                stroke(b)
                text("A", a)
                text("B", b)
                Connection(a, b; smoothprops, control_points=cps) |> stroke
                @layer begin
                    fontsize(14)
                    text(string(get(smoothprops, :method, "")), offset(midpoint(a, b), (0, 70)))
                end
            end
        end
    end
end

using Test
using LuxorGraphPlot: angleof, closest_natural_point, getpath
using LuxorGraphPlot
using Luxor

@testset "angleof and boundary" begin
    @test angleof(Point(0.5*sqrt(3.0), 0.5)) ≈ π/6
    n = boxnode(O, 100, 100)
    path = getpath(n)
    @test boundary(n, angleof(Point(0.5*sqrt(3.0), 0.5))).loc ≈ Point(50, 50/sqrt(3))
    @test closest_natural_point(path, Point(100, 120)) ≈ Point(50, 50)
    @test closest_natural_point(path, Point(130, -120)) ≈ Point(50, -50)
    @test closest_natural_point(path, Point(130, -10)) ≈ Point(50, 0)
end

@testset "nodes" begin
    # circle
    n = circlenode((0.2, 0.4), 0.5)
    @test right(n).loc == Point(0.7, 0.4)
    @test left(n).loc == Point(-0.3, 0.4)
    @test bottom(n).loc == Point(0.2, 0.9)
    @test top(n).loc == Point(0.2, -0.1)
    
    # ellipse
    n = ellipsenode((0.2, 0.4), 1.0, 2.0)
    @test right(n).loc == Point(0.7, 0.4)
    @test left(n).loc == Point(-0.3, 0.4)
    @test bottom(n).loc == Point(0.2, 1.4)
    @test top(n).loc == Point(0.2, -0.6)

    # box
    n = boxnode((0.2, 0.4), 1.0, 0.4)
    @test right(n).loc == Point(0.7, 0.4)
    @test left(n).loc == Point(-0.3, 0.4)
    @test top(n).loc == Point(0.2, 0.2)
    @test bottom(n).loc == Point(0.2, 0.6)

    # polygon
    path = getpath(n)
    n = polygonnode((0.2, 0.4), path .- Ref(Point(0.2, 0.4)))
    @test right(n).loc == Point(0.7, 0.4)
    @test left(n).loc == Point(-0.3, 0.4)
    @test bottom(n).loc == Point(0.2, 0.6)
    @test top(n).loc == Point(0.2, 0.2)

    # dot
    n = dotnode((0.2, 0.4))
    @test right(n).loc == Point(0.2, 0.4)
    @test left(n).loc == Point(0.2, 0.4)
    @test top(n).loc == Point(0.2, 0.4)
    @test bottom(n).loc == Point(0.2, 0.4)

    # line
    n = linenode((-0.1, 0.2), (0.3, 0.4))
    @test right(n).loc == Point(0.3, 0.4)
    @test left(n).loc == Point(-0.1, 0.2)
    @test bottom(n).loc == Point(0.3, 0.4)
    @test top(n).loc == Point(-0.1, 0.2)
end

@testset "connection" begin
    n = boxnode((0.2, 0.4), 1.0, 0.4)
    @test Connection(left(n), right(n)) isa Connection
end

using LuxorGraphPlot.TensorNetwork, Luxor, Test, LuxorGraphPlot

@testset "mps" begin
    diagram = mps(4)
    fig = with_nodes(diagram) do
        for (i, node) in enumerate(diagram.nodes)
            LuxorGraphPlot.stroke(node)
            text("A($i)", node)
        end
        for edge in diagram.edges
            LuxorGraphPlot.stroke(edge)
        end
    end
    display(fig)
    @test fig isa Drawing
end

using LuxorGraphPlot
using Luxor
using Test

@testset "nodestore" begin
    drawing = nodestore() do ns
        c1 = circle!((0.4, 0.5), 30)
        c2 = circle!((0.4, 0.5), 80)
        with_nodes() do
            sethue("white")
            fill(c1)
            fill(c2)
            sethue("black")
            text("y", c1)
            text("x", c2)
            line(c1, c2)
            stroke(c1)
            stroke(c2)
        end
    end
    @test drawing isa Drawing
end

using LuxorGraphPlot, Graphs
using Luxor
using Test

@testset "GraphDisplayConfig" begin
    config = GraphDisplayConfig()
    @test config isa GraphDisplayConfig
    c1 = darktheme!(copy(config))
    @test c1 isa GraphDisplayConfig
    @test c1.vertex_stroke_color == "white"
    c2 = lighttheme!(copy(config))
    @test c2 isa GraphDisplayConfig
    @test c2.vertex_stroke_color == "black"
end

@testset "GraphViz" begin
    graph = smallgraph(:petersen)
    gv = GraphViz(graph)
    @test gv isa GraphViz
    @test gv.locs isa Array
end

@testset "graph plot" begin
    locations = [(50.0, 100.0), (100.0, 150.0)]
    @test show_graph(GraphViz(locs=locations, edges=[(1, 2)])) isa Drawing
    gv = GraphViz(locs=[], edges=[])
    @test show_graph(gv) isa Drawing
    @test show_graph(gv; format=:pdf) isa Drawing
    @test show_graph(gv; filename=tempname()*".svg") isa Drawing
    graph = smallgraph(:petersen)
    @test show_graph(graph) isa Drawing
    show_graph(graph; vertex_shapes=fill(:box, 10)) isa Drawing
end

@testset "gallery" begin
    graph = smallgraph(:petersen)
    locs = render_locs(graph, StressLayout())
    matrix = [GraphViz(graph, locs; vertex_colors=[rand(Luxor.RGB) for i=1:10], edge_colors=[rand(Luxor.RGB) for i=1:15]) for i=1:2, j=1:4]
    # gallery
    @test show_gallery(matrix) isa Drawing 
    @test show_gallery(reshape(GraphViz[], 0, 0)) isa Drawing
end

"""
    Point{D, T}

A point in D-dimensional space, with coordinates of type T.
"""
struct Point{D, T <: Real}
    data::NTuple{D, T}
end
const Point2D{T} = Point{2, T}
const Point3D{T} = Point{3, T}
dimension(::Point{D}) where D = D
Base.eltype(::Type{Point{D, T}}) where {D, T} = T
Point(x::Real...) = Point((x...,))
Point(x::Point) = x
LinearAlgebra.dot(x::Point, y::Point) = mapreduce(*, +, x.data .* y.data)
LinearAlgebra.norm(x::Point) = sqrt(sum(abs2, x.data))
Base.:*(x::Real, y::Point) = Point(x .* y.data)
Base.:*(x::Point, y::Real) = Point(x.data .* y)
Base.:/(y::Point, x::Real) = Point(y.data ./ x)
Base.:+(x::Point, y::Point) = Point(x.data .+ y.data)
Base.:-(x::Point, y::Point) = Point(x.data .- y.data)
Base.isapprox(x::Point, y::Point; kwargs...) = all(isapprox.(x.data, y.data; kwargs...))
Base.getindex(p::Point, i::Int) = p.data[i]
Base.broadcastable(p::Point) = p.data
Base.iterate(p::Point, args...) = iterate(p.data, args...)
Base.zero(::Type{Point{D, T}}) where {D, T} = Point(ntuple(i->zero(T), D))
Base.zero(::Point{D, T}) where {D, T} = Point(ntuple(i->zero(T), D))
distance(p::Point, q::Point) = norm(p - q)
Base.rand(::Type{Point{D, T}}) where {D, T} = Point(ntuple(_->rand(T), D))
Base.randn(::Type{Point{D, T}}) where {D, T} = Point(ntuple(_->randn(T), D))
Base.isfinite(p::Point) = all(isfinite, p.data)
rand_points_2d(n::Int) = [Point(randn(), randn()) for _ in 1:n]

"""
    SpectralLayout <: AbstractLayout

A layout algorithm based on spectral graph theory.

### Fields
* `optimal_distance::Float64`: the optimal distance between vertices
* `dimension::Int`: the number of dimensions
"""
@kwdef struct SpectralLayout <: AbstractLayout
    optimal_distance::Float64 = 50.0
    dimension::Int = 2
end

function render_locs(graph, l::SpectralLayout)
    return spectral_layout(graph;
                        optimal_distance=l.optimal_distance,
                        dimension=l.dimension
                    )
end

"""
    spectral_layout(g::AbstractGraph, weight=nothing; optimal_distance=50.0)

Spectral layout for graph plotting, returns a vector of vertex locations.
"""
function spectral_layout(g::AbstractGraph, weight=nothing; optimal_distance=50.0, dimension=2)
    if nv(g) == 1
        return [zero(Point{dimension, Float64})]
    elseif nv(g) == 2
        return [zero(Point{dimension, Float64}), Point(ntuple(i->i==1 ? Float64(optimal_distance) : 0.0, dimension))]
    end

    if weight === nothing
        weight = ones(ne(g))
    end
    if nv(g) > 500
        A = Graphs.sparse(Int[src(e) for e in edges(g)],
                   Int[dst(e) for e in edges(g)],
                   weight, nv(g), nv(g))
        if is_directed(g)
            A = A + transpose(A)
        end
        return _spectral(A, dimension) .* 16optimal_distance
    else
        L = laplacian_matrix(g)
        return _spectral(Matrix(L), dimension) .* 16optimal_distance
    end
end

function _spectral(L::Matrix, dimension)
    eigenvalues, eigenvectors = eigen(L)
    index = sortperm(eigenvalues)[2:1+dimension]
    return Point.([eigenvectors[:, idx] for idx in index]...)
end

function _spectral(A, dimension)
    data = vec(sum(A, dims=1))
    D = Graphs.sparse(Base.OneTo(length(data)), Base.OneTo(length(data)), data)
    L = D - A
    eigenvalues, eigenvectors = Graphs.LinAlg.eigs(L, nev=3, which=Graphs.SR())
    index = sortperm(real(eigenvalues))[2:1+dimension]
    return Point.([real.(eigenvectors[:, idx]) for idx in index]...)
end

function serve(;host::String="0.0.0.0", port::Int=8000)
    # setup environment
    docs_dir = @__DIR__
    julia_cmd = "using Pkg; Pkg.instantiate()"
    run(`$(Base.julia_exename()) --project=$docs_dir -e $julia_cmd`)

    serve_cmd = """
    using LiveServer;
    LiveServer.servedocs(;
        doc_env=true,
        skip_dirs=[
            #joinpath("docs", "src", "generated"),
            joinpath("docs", "src"),
            joinpath("docs", "build"),
            joinpath("docs", "Manifest.toml"),
        ],
        literate="examples",
        host=\"$host\",
        port=$port,
    )
    """
    try
        run(`$(Base.julia_exename()) --project=$docs_dir -e $serve_cmd`)
    catch e
        if e isa InterruptException
            return
        else
            rethrow(e)
        end
    end
    return
end

serve()

"""
    SpringLayout <: AbstractLayout

A layout algorithm based on a spring model.

### Fields
* `optimal_distance::Float64`: the optimal distance between vertices
* `maxiter::Int`: the maximum number of iterations
* `α0::Float64`: the initial moving speed
* `meta::Dict{Symbol, Any}`: graph dependent meta information, including
    * `initial_locs`: initial vertex locations
    * `mask`: boolean mask for which vertices to relocate
"""
@kwdef struct SpringLayout <: AbstractLayout
    optimal_distance::Float64 = 50.0
    maxiter::Int = 100
    α0::Float64 = 2*optimal_distance  # initial moving speed
    meta::Dict{Symbol, Any} = Dict{Symbol, Any}()
end

function render_locs(graph, l::SpringLayout)
    return spring_layout(graph;
                        optimal_distance=l.optimal_distance,
                        maxiter=l.maxiter,
                        α0=l.α0,
                        locs=get(l.meta, :initial_locs, nothing),
                        mask=get(l.meta, :mask, nothing),
                    )
end

"""
    spring_layout(g::AbstractGraph;
                       locs=nothing,
                       optimal_distance=50.0,   # the optimal vertex distance
                       maxiter=100,
                       α0=2*optimal_distance,  # initial moving speed
                       mask::AbstractVector{Bool}=trues(nv(g))   # mask for which to relocate
                       )

Spring layout for graph plotting, returns a vector of vertex locations.

!!! note
    This function is copied from [`GraphPlot.jl`](https://github.com/JuliaGraphs/GraphPlot.jl),
    where you can find more information about his function.
"""
function spring_layout(g::AbstractGraph;
                       locs=nothing,
                       optimal_distance=50.0,   # the optimal vertex distance
                       maxiter=100,
                       α0=2*optimal_distance,
                       mask=nothing,
                       )
    locs = locs === nothing ? rand_points_2d(nv(g)) : Point.(locs) ./ optimal_distance
    mask = mask === nothing ? trues(nv(g)) : mask
    @assert nv(g) == length(locs) "number of vertices in graph and locs must be the same, got $(nv(g)) and $(length(locs))"

    # Store forces and apply at end of iteration all at once
    force = zero(locs)

    # Iterate maxiter times
    @inbounds for iter = 1:maxiter
        # Cool down
        temp = α0 / iter
        spring_step!(g, locs, force; optimal_distance=1.0, temp, mask)
    end

    optimal_distance .* locs
end


function spring_step!(g::AbstractGraph, locs, force;
                       optimal_distance, temp, mask)
    # Calculate forces
    for i = 1:nv(g)
        force_i = zero(eltype(locs))
        for j = 1:nv(g)
            i == j && continue
            dist = distance(locs[i], locs[j])

            if has_edge(g, i, j)
                # Attractive + repulsive force
                # F_d = dist² / k - k² / dist # original FR algorithm
                F_d = dist / optimal_distance - optimal_distance^2 / dist^2
            else
                # Just repulsive
                # F_d = -k² / dist  # original FR algorithm
                F_d = -optimal_distance^2 / dist^2
            end
            force_i += F_d * (locs[j] - locs[i])
        end
        force[i] = force_i
    end
    # Now apply them, but limit to temperature
    for i = 1:nv(g)
        mask[i] || continue
        force_mag  = norm(force[i])
        scale      = min(force_mag, temp) / force_mag
        locs[i] += force[i] * scale
    end
end

"""
    LayeredSpringLayout(; zlocs, optimal_distance, aspect_ration=0.2)

Create a layered spring layout.

### Keyword Arguments
* `zlocs`: the z-axis locations
* `optimal_distance::Float64`: the optimal distance between vertices
* `aspect_ration::Float64`: the aspect ratio of the z-axis
* `α0::Float64`: the initial moving speed
* `maxiter::Int`: the maximum number of iterations
"""
function LayeredSpringLayout(; zlocs, optimal_distance=50.0, aspect_ratio=0.2, α0=2*optimal_distance, maxiter=100)
    return Layered(SpringLayout(; optimal_distance, α0, maxiter), zlocs, aspect_ratio)
end

using Test, LuxorGraphPlot, Graphs
using Luxor: Drawing, RGB
using LuxorGraphPlot.Layouts

@testset "stress layout" begin
    Random.seed!(0)
    for n =[100, 2000]
        graph = random_regular_graph(n, 3)
        optimal_distance = 50
        locs = Layouts.spectral_layout(graph; optimal_distance)
        @test locs isa Vector{<:Layouts.Point{2}}
        Q = Layouts.quality_of_layout(graph, locs, optimal_distance)
        @test Q.closeness > 10000 && Q.mean_distance_deviation < 3
    end
    graph = SimpleGraph(1)
    optimal_distance = 50
    locs = Layouts.spectral_layout(graph; optimal_distance)
    @test locs isa Vector{<:Layouts.Point{2}} && length(locs) == 1

    graph = SimpleGraph(2)
    add_edge!(graph, 1, 2)
    optimal_distance = 50
    locs = Layouts.spectral_layout(graph; optimal_distance)
    @test locs isa Vector{<:Layouts.Point{2}} && length(locs) == 2
end

@testset "data types" begin
    graph = random_regular_graph(100, 3)
    optimal_distance = 50.0
    # without initial locations
    layout = Layouts.SpectralLayout(; optimal_distance)
    @test layout isa Layouts.SpectralLayout
    @test Layouts.render_locs(graph, layout) isa Vector{<:Layouts.Point{2}}
end

module TensorNetwork
using ..LuxorGraphPlot
import ..LuxorGraphPlot: AbstractNodeStore, nodes
using Luxor

export mps, TensorNetworkDiagram
struct TensorNetworkDiagram <: AbstractNodeStore
    nodes::Vector{Node}
    dots::Vector{Node}
    edges::Vector{Connection}
end
nodes(tn::TensorNetworkDiagram) = [tn.nodes..., tn.dots...]

# tensor network visualization
function mps(n::Int; radius=15, distance=50, offset=(0, 0))
    nodes = [circlenode(LuxorGraphPlot.topoint(offset) + Point((i-1) * distance, 0), radius) for i=1:n]
    # pins
    pins = [LuxorGraphPlot.offset(center(a), "top", distance ÷ 2) for a in nodes]
    # edges
    edges = [[connect(a, b) for (a, b) in zip(nodes[1:end-1], nodes[2:end])]...,
                [connect(a, b) for (a, b) in zip(nodes, pins)]...]
    return TensorNetworkDiagram(nodes, pins, edges)
end

end

using Pkg
using LuxorGraphPlot
using Documenter
using DocThemeIndigo
using Literate

for each in readdir(pkgdir(LuxorGraphPlot, "examples"))
    input_file = pkgdir(LuxorGraphPlot, "examples", each)
    endswith(input_file, ".jl") || continue
    @info "building" input_file
    output_dir = pkgdir(LuxorGraphPlot, "docs", "src", "generated")
    Literate.markdown(input_file, output_dir; name=each[1:end-3], execute=false)
end

indigo = DocThemeIndigo.install(LuxorGraphPlot)
DocMeta.setdocmeta!(LuxorGraphPlot, :DocTestSetup, :(using LuxorGraphPlot); recursive=true)

makedocs(;
    modules=[LuxorGraphPlot],
    authors="Jinguo Liu",
    #repo="https://github.com/GiggleLiu/LuxorGraphPlot.jl/blob/{commit}{path}#{line}",
    sitename="LuxorGraphPlot.jl",
    format=Documenter.HTML(;
        prettyurls=get(ENV, "CI", "false") == "true",
        canonical="https://giggleliu.github.io/LuxorGraphPlot.jl",
        assets=String[indigo],
    ),
    pages=[
        "Home" => "index.md",
        "Examples" => [
            "Tutorials" => "generated/tutorials.md",
            "Features" => "generated/features.md",
        ],
        "References" => "ref.md",
    ],
    doctest=false,
    warnonly = :missing_docs,
)

deploydocs(;
    repo="github.com/GiggleLiu/LuxorGraphPlot.jl",
)

"""
    AbstractLayout

Abstract type for layout algorithms.
"""
abstract type AbstractLayout end

"""
    render_locs(graph, layout::Layout)

Render the vertex locations for a graph from an [`AbstractLayout`](@ref) instance.

### Arguments
* `graph::AbstractGraph`: the graph to render
* `layout::AbstractLayout`: the layout algorithm
"""
function render_locs(graph::AbstractGraph, layout::AbstractVector)
    @assert nv(graph) == length(layout) "The number of vertices in the graph must match the number of locations, got $(nv(graph)) vertices and $(length(layout)) locations"
    return Point.(layout)
end

"""
    Layered <: AbstractLayout

Layered version of a parent layout algorithm.

### Fields
* `parent::LT`: the parent layout algorithm
* `zlocs::Vector{T}`: the z-axis locations
* `aspect_ratio::Float64`: the aspect ratio of the z-axis
"""
struct Layered{LT<:AbstractLayout, T} <: AbstractLayout
    parent::LT
    zlocs::Vector{T}
    aspect_ratio::Float64
end

function render_locs(graph, l::Layered)
    @assert nv(graph) == length(l.zlocs) "The number of vertices in the graph must match the number of z-axis locations, got $(nv(graph)) vertices and $(length(l.zlocs)) z-axis locations"
    locs = render_locs(graph, l.parent)
    map(lz->Point(lz[1][1], lz[1][2]* l.aspect_ratio + lz[2]), zip(locs, l.zlocs))
end

struct LayoutQuality
    closeness::Float64
    mean_distance_deviation::Float64
end

function quality_of_layout(graph, locs, optimal_distance)
    average_distance_con = sum([Layouts.distance(locs[e.src], locs[e.dst]) for e in edges(graph)])/ne(graph)
    average_distance_dis = sum([Layouts.distance(locs[e.src], locs[e.dst]) for e in edges(complement(graph))])
    deviation = abs(average_distance_con - optimal_distance) / min(optimal_distance, average_distance_con)
    return LayoutQuality(average_distance_dis/average_distance_con, deviation)
end

const REQUIRED_PARAMS = Dict(
    :circle => [:radius],
    :ellipse => [:width, :height],
    :box => [:width, :height],
    :polygon => [:relpath],
    :line => [:relpath],
    :dot => Symbol[]
)

const OPTIONAL_PARAMS = Dict(
    :circle => Dict{Symbol, Any}(),
    :ellipse => Dict{Symbol, Any}(),
    :box => Dict{Symbol, Any}(:smooth=>0),
    :polygon => Dict{Symbol, Any}(:smooth=>0, :close=>true),
    :line => Dict{Symbol, Any}(:arrowstyle=>"-"),
    :dot => Dict{Symbol, Any}()
)

dict2md(d::Dict) = join(["- `$(k)`: $(v)" for (k, v) in d], "\n")

"""
    Node(shape::Symbol, loc; props...)

Create a node with a shape and a location. The shape can be `:circle`, `:ellipse`, `:box`, `:polygon`, `:line` or `:dot`.

### Required Keyword Arguments
$(dict2md(REQUIRED_PARAMS))

### Optional Keyword Arguments
$(dict2md(OPTIONAL_PARAMS))
"""
struct Node
    shape::Symbol
    loc::Point
    props::Dict{Symbol, Any}
end
function Node(shape::Symbol, loc; props...)
    d = Dict{Symbol, Any}(props)
    check_props!(shape, d)
    return Node(shape, topoint(loc), d)
end

"""
    offset(n::Node, p::Union{Tuple,Point})
    offset(n::Node, direction, distance)
    offset(n::Node, direction::Node, distance)

Offset a node towards a direction or another node. The direction can be specified by a tuple, a `Point` or a `Node`.
"""
offset(n::Node, p::Union{Tuple,Point}) = Node(n.shape, n.loc + topoint(p), n.props)
offset(n::Node, direction, distance) = offset(n, render_offset(direction, distance))
function offset(n::Node, direction::Node, distance)
    p = direction.loc - n.loc
    return offset(n, normalize(p) * distance)
end
function render_offset(direction, distance)
    angle = render_direction(direction)
    return Point(distance * cos(angle), -distance * sin(angle))
end
render_direction(s) = @match s begin
    ::Real => Float64(s)
    "right" => 0.0
    "topright" => 7π/4
    "top" => -π/2
    "topleft" => 5π/4
    "left" => 1.0π
    "bottomleft" => 3π/4
    "bottom" => -3π/2
    "bottomright" => π/4
end
Luxor.distance(a::Node, b::Node) = distance(a.loc, b.loc)
topoint(x::Point) = x
topoint(x::Node) = x.loc
topoint(x::Tuple) = Point(x...)
"""
    dotnode(x, y)
    dotnode(p::Point)

Create a node with a shape `:dot` and a location.
"""
dotnode(x::Real, y::Real) = dotnode(Point(x, y))
dotnode(p) = Node(:dot, topoint(p))

"""
    circle(loc, radius; props...) = Node(:circle, loc; radius, props...)
"""
circlenode(loc, radius) = Node(:circle, loc; radius)
"""
    ellipse(loc, width, height; props...) = Node(:ellipse, loc; width, height, props...)
"""
ellipsenode(loc, width, height) = Node(:ellipse, loc; width, height)
"""
    box(loc, width, height; props...) = Node(:box, loc; width, height, props...)
"""
boxnode(loc, width, height; kwargs...) = Node(:box, loc; width, height, kwargs...)
"""
    polygon([loc, ]relpath::AbstractVector; props...) = Node(:polygon, loc; relpath, props...)
"""
polygonnode(loc, relpath::AbstractVector; kwargs...) = Node(:polygon, loc; relpath=topoint.(relpath), kwargs...)
function polygonnode(path::AbstractVector; kwargs...)
    mid, relpath = centerize([topoint(x) for x in path])
    Node(:polygon, mid; relpath, kwargs...)
end
"""
    line(args...; props...) = Node(:line, mid; relpath, props...)
"""
function linenode(args...)
    mid, relpath = centerize([topoint(x) for x in args])
    return Node(:line, mid; relpath)
end
function centerize(path)
    mid = sum(path) / length(path)
    return mid, path .- mid
end
function check_props!(shape, props)
    assert_has_props!(shape, props, REQUIRED_PARAMS[shape], OPTIONAL_PARAMS[shape])
end
function assert_has_props!(shape, props, syms, optional)
    # required arguments
    for sym in syms
        if !haskey(props, sym)
            error("missing property (keyword argument) for shape $shape: $sym ")
        end
    end
    # optional arguments
    for (k, v) in optional
        if !haskey(props, k)
            props[k] = v
        end
    end
    # not recognized arguments
    for (k, v) in props
        if !(k ∈ syms || haskey(optional, k))
            @warn "property not recognized by shape $shape: $k"
        end
    end
    return true
end
function Base.getproperty(n::Node, p::Symbol)
    return hasfield(Node, p) ? getfield(n, p) : n.props[p]
end

"""
    Connection(start, stop; isarrow=false, mode=:exact, arrowprops=Dict{Symbol, Any}(), control_points=Point[], smoothprops=Dict{Symbol, Any}())

Create a connection between two nodes. The connection can be a line, a curve, a bezier curve, a smooth curve or a zig-zag line.

### Required Arguments
- `start::Node`: the start node
- `stop::Node`: the stop node

### Optional Keyword Arguments
- `isarrow=false`: whether to draw an arrow at the end of the connection
- `mode=:exact`: the mode to get the connection point, can be `:exact` or `:natural`
- `arrowprops=Dict{Symbol, Any}()`: the properties of the arrow
- `control_points=Point[]`: the control points for the connection
- `smoothprops=Dict{Symbol, Any}()`: the properties of the smooth curve
"""
struct Connection
    start::Node
    stop::Node
    mode::Symbol
    isarrow::Bool
    arrowprops::Dict{Symbol, Any}
    control_points::Vector{Point}
    smoothprops::Dict{Symbol, Any}
end
# TODO: polish arrow props, smooth corners
function Connection(start::Node, stop::Node; isarrow=false, mode=:exact, arrowprops=Dict{Symbol, Any}(), control_points=Point[], smoothprops=Dict{Symbol, Any}())
    return Connection(start, stop, mode, isarrow, arrowprops, Point[topoint(x) for x in control_points], smoothprops)
end
offset(c::Connection, p::Union{Tuple,Point}) = Connection(offset(c.start, p), offset(c.stop, p); c.mode, c.isarrow, c.arrowprops, c.control_points, c.smoothprops)
connect(a, b; kwargs...) = Connection(tonode(a), tonode(b); kwargs...)
tonode(a::Point) = dotnode(a)
tonode(a::Node) = a

"""
    circle(n::Node, action=:stroke)

Stroke a node with line.
"""
stroke(n::Union{Node, Connection}) = (apply_action(n, :stroke); n)
Base.fill(n::Union{Node, Connection}) = (apply_action(n, :fill); n)
function Luxor.text(t::AbstractString, n::Node; angle=0.0)
    text(t, n.loc; valign=:middle, halign=:center, angle)
end
function apply_action(n::Node, action)
    @match n.shape begin
        :circle => circle(n.loc, n.radius, action)
        :ellipse => ellipse(n.loc, n.width, n.height, action)
        :box => box(n.loc, n.width, n.height, n.smooth, action)
        :polygon => if n.props[:smooth] == 0
                poly(Ref(n.loc) .+ n.relpath, action; close=n.props[:close])
            else
                #move(n.loc + n.relpath[1])
                polysmooth(Ref(n.loc) .+ n.relpath, n.props[:smooth], action)
            end
        :line => line((Ref(n.loc) .+ n.relpath)..., action)
        :dot => nothing #circle(n.loc, 1, action)  # dot has unit radius
    end
end
function apply_action(n::Connection, action)
    a_ = get_connect_point(n.start, isempty(n.control_points) ? n.stop.loc : n.control_points[1]; mode=n.mode)
    b_ = get_connect_point(n.stop, isempty(n.control_points) ? n.start.loc : n.control_points[end]; mode=n.mode)
    if n.isarrow
        # arrow, line or curve
        arrow(a_, n.control_points..., b_; n.arrowprops...)
        do_action(action)
    else
        method = get(n.smoothprops, :method, "curve")
        @assert method ∈ ["nosmooth", "smooth", "bezier", "curve"]
        if method == "nosmooth" || isempty(n.control_points)
            if isempty(n.control_points)
                # line
                line(a_, b_, action)
            else
                # zig-zag line
                # TODO: support arrow
                poly([a_, n.control_points..., b_], action; close=false)
            end
        elseif method == "smooth"
                # TODO: support close=false
                #move(a_)
                polysmooth([a_, n.control_points..., b_], get(n.smoothprops, :radius, 5), action; close=false)
        elseif method == "bezier"
            # bezier curve
            pts = [a_, n.control_points..., b_]
            bezpath = makebezierpath(pts)
            drawbezierpath(bezpath, action, close=false)
        else
            # curve
            move(a_)
            curve(n.control_points..., b_)
            do_action(action)
        end
    end
end

xmin(path) = minimum(x->x.x, path)
xmax(path) = maximum(x->x.x, path)
ymin(path) = minimum(x->x.y, path)
ymax(path) = maximum(x->x.y, path)
for F in [:left, :right, :top, :bottom, :topright, :topleft, :bottomleft, :bottomright]
    SF = String(F)
    @eval begin
    """
        $($SF)(n::Node)

    Get the $($SF) boundary point of a node. Returns a `Node` of shape `:dot`.
    """
    $F(n::Node) = boundary(n, $(String(F)))
    end
end

"""
    midpoint(a::Node, b::Node)

Get the midpoint of two nodes. Returns a `Node` of shape `:dot`.
"""
Luxor.midpoint(a::Node, b::Node) = dotnode(midpoint(a.loc, b.loc))

"""
    center(n::Node)

Get the center point of a node. Returns a `Node` of shape `:dot`.
"""
center(n::Node) = dotnode(n.loc)

"""
    boundary(n::Node, s::String)
    boundary(n::Node, angle::Real)

Get the boundary point of a node in a direction. The direction can be specified by a string or an angle.
Possible strings are: "left", "right", "top", "bottom", "topright", "topleft", "bottomleft", "bottomright".
"""
boundary(n::Node, s::String) = boundary(n, render_direction(s))

function boundary(n::Node, angle::Real)
    @match n.shape begin
        :circle => dotnode(n.loc.x + n.radius * cos(angle), n.loc.y + n.radius * sin(angle))
        :ellipse => dotnode(n.loc.x + n.width/2 * cos(angle), n.loc.y + n.height/2 * sin(angle))
        # TODO: polish for rounded corners
        :box || :polygon => begin
            path = getpath(n)
            radi = max(xmax(path) - xmin(path), ymax(path) - ymin(path))
            x = n.loc.x + 2*radi * cos(angle)
            y = n.loc.y + 2*radi * sin(angle)
            # NOTE: polygon must intersect with its center!
            intersect = intersectlinepoly(n.loc, Point(x, y), path)
            if isempty(intersect)
                @warn "boundary point not found, return center instead: path=$path, angle=$angle"
                return center(n)
            else
                return dotnode(intersect[1])
            end
        end
        :dot => n
        :line => begin
            path = getpath(n)
            # project to angle direction, find the one with the largest norm
            unitv = Point(cos(angle), sin(angle))
            projects = dotproduct.(Ref(unitv), path)
            mval, mloc = findmax(projects)
            return dotnode(path[mloc])
        end
        _ => error("can not get boundary point for shape: $(n.shape)")
    end
end

bottomalign(n::Node, target::Node) = bottomalign(n, target.loc[1])
bottomalign(n::Node, x::Real) = dotnode(x, bottom(n).loc[2])
topalign(n::Node, target::Node) = topalign(n, target.loc[1])
topalign(n::Node, x::Real) = dotnode(x, top(n).loc[2])
leftalign(n::Node, target::Node) = topalign(n, target.loc[2])
leftalign(n::Node, y::Real) = dotnode(left(n).loc[1], y)
rightalign(n::Node, target::Node) = rightalign(n, target.loc[2])
rightalign(n::Node, y::Real) = dotnode(right(n).loc[1], y)

# get the path of a node
function getpath(n::Node)
    @match n.shape begin
        :circle => [Point(n.loc.x + n.radius * cos(θ), n.loc.y + n.radius * sin(θ)) for θ in 0:π/8:2π]
        :ellipse => [Point(n.loc.x + n.width/2 * cos(θ), n.loc.y + n.height/2 * sin(θ)) for θ in 0:π/8:2π]
        :box => begin
            x, y = n.loc
            w, h = n.width, n.height
            [Point(x-w/2, y-h/2), Point(x-w/2, y+h/2), Point(x+w/2, y+h/2), Point(x+w/2, y-h/2)]
        end
        :polygon => Ref(n.loc) .+ n.relpath
        :dot => [n.loc]
        :line => Ref(n.loc) .+ n.relpath
    end
end

function Luxor.line(a::Node, b::Node, action=:stroke; mode=:exact, kwargs...)
    a_ = get_connect_point(a, b.loc; mode)
    b_ = get_connect_point(b, a.loc; mode)
    line(a_, b_, action; kwargs...)
end
function Luxor.arrow(a::Node, b::Node, action=:stroke; mode=:exact, kwargs...)
    a_ = get_connect_point(a, b.loc; mode)
    b_ = get_connect_point(b, a.loc; mode)
    arrow(a_, b_; kwargs...)
    do_action(action)
end

function get_connect_point(a::Node, bloc::Point; mode)
    @match a.shape begin
        :circle => intersectionlinecircle(a.loc, bloc, a.loc, a.radius)[2]
        :ellipse => boundary(a, angleof(bloc-a.loc)).loc
        :dot => a.loc
        :line => a.loc + a.relpath[end]  # the last node
        :box || :polygon => @match mode begin
            :natural => closest_natural_point(getpath(a), bloc)
            :exact => boundary(a, angleof(bloc-a.loc)).loc
            _ => error("Connection point mode `:$(mode)` is not defined!")
        end
    end
end

angleof(p::Point) = atan(p.y, p.x)

function closest_natural_point(path::AbstractVector, p::Point)
    minval, idx = findmin(x->distance(p, x), path)
    mid = i->midpoint(path[i], path[mod1(i+1, length(path))])
    minval2, idx2 = findmin(i->distance(p, mid(i)), 1:length(path))
    return minval > minval2 ? mid(idx2) : path[idx]
end

using Test, LuxorGraphPlot, Graphs
using LuxorGraphPlot.Layouts
using Luxor: Drawing, RGB
using Random

@testset "spring layout" begin
    graph = random_regular_graph(100, 3)
    optimal_distance = 50
    locs = Layouts.spring_layout(graph; optimal_distance)
    @test locs isa Vector{<:Layouts.Point{2}}
    Q = Layouts.quality_of_layout(graph, locs, optimal_distance)
    @test Q.closeness > 10000 && Q.mean_distance_deviation < 5
end

@testset "data types" begin
    graph = random_regular_graph(100, 3)
    optimal_distance = 50.0
    # without initial locations
    layout = Layouts.SpringLayout(; optimal_distance)
    @test layout isa Layouts.SpringLayout
    @test Layouts.render_locs(graph, layout) isa Vector{<:Layouts.Point{2}}

    # with initial locations
    layout = Layouts.SpringLayout(; optimal_distance, meta=Dict(:initial_locs=>Layouts.rand_points_2d(100)))
    @test Layouts.render_locs(graph, layout) isa Vector{<:Layouts.Point{2}}

    # with initial locations and mask
    layout = Layouts.SpringLayout(; optimal_distance, meta=Dict(:initial_locs=>Layouts.rand_points_2d(100), :mask=>trues(100)))
    @test Layouts.render_locs(graph, layout) isa Vector{<:Layouts.Point{2}}

    # layered
    zlocs = rand([0,200], nv(graph))
    layout = Layouts.LayeredSpringLayout(; zlocs, optimal_distance)
    @test Layouts.render_locs(graph, layout) isa Vector{<:Layouts.Point{2}}
end

module LayoutsTest
using Test, LuxorGraphPlot, Graphs

@testset "point" begin
    include("point.jl")
end

@testset "spring" begin
    include("spring.jl")
end

@testset "stress" begin
    include("stress.jl")
end

@testset "spectral" begin
    include("spectral.jl")
end

@testset "layouts" begin
    graph = smallgraph(:petersen)
    for layout in [
                [(randn(), randn()) for i=1:nv(graph)],
                SpringLayout(),
                StressLayout(),
                SpectralLayout(),
                LayeredStressLayout(zlocs=rand([0,200], nv(graph))),
                LayeredSpringLayout(zlocs=rand([0,200], nv(graph))),
            ]
        @test show_graph(graph, layout) isa Drawing
        gs = [GraphViz(graph, layout; vertex_sizes=rand(Bool, 10) .* 100, edge_colors=rand(RGB, 15)) for i=1:2, j=1:4]
        @test show_gallery(gs) isa Drawing
    end
    locs = [(randn(2)...,) for i=1:10]
    @test show_graph(graph, SpringLayout()) isa Drawing
    gs = [GraphViz(graph, SpringLayout(); vertex_sizes=rand(Bool, 10) .* 100, edge_colors=rand(RGB, 15)) for i=1:2, j=1:4]
    @test show_gallery(gs) isa Drawing
end
end

```@meta
CurrentModule = LuxorGraphPlot
```

# LuxorGraphPlot

## Features
1. automatically detecting the size of the diagram by combining [`nodestore`](@ref) and [`with_nodes`](@ref).
2. connecting nodes with edges, finding middle points and corners of the nodes. Related APIs: `Luxor.midpoint`, [`left`](@ref), [`right`](@ref), [`top`](@ref), [`bottom`](@ref), [`center`](@ref), [`boundary`](@ref).
3. simple graph layouts, such as [`SpringLayout`](@ref), [`StressLayout`](@ref), [`SpectralLayout`](@ref), [`LayeredSpringLayout`](@ref) and [`LayeredStressLayout`](@ref).
